﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace Post6394
{
    public partial class _Default : System.Web.UI.Page
    {
        private LayerOverlay mapOverlay;
        protected void Page_Load(object sender, EventArgs e)
        {
            mapOverlay = new LayerOverlay();
            if (!IsPostBack)
            {
                Map1.MapUnit = GeographyUnit.DecimalDegree;
            }
        }

        private void Open_Raster_Map(string MpPath)
        {

            if (mapOverlay.Layers.Contains(MapPath(MpPath)))
            {
                mapOverlay.Layers.Remove(MapPath(MpPath));
            }

            Map1.MapUnit = GeographyUnit.DecimalDegree;

            Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);
            GdiPlusRasterLayer mapLayer = new GdiPlusRasterLayer(MapPath(MpPath));
            mapLayer.UpperThreshold = double.MaxValue;
            mapLayer.LowerThreshold = 0;

            mapLayer.Name = "Erin1";
            mapLayer.Open();

            mapOverlay.Layers.Add(MapPath(MpPath), mapLayer);

            Map1.CustomOverlays.Add(mapOverlay);


            Map1.CurrentExtent = GetFullExtent();
        }

        private RectangleShape GetFullExtent()
        {
            RectangleShape functionReturnValue = default(RectangleShape);
            try
            {
                RectangleShape boundingBox = null;

                foreach (Overlay myOverlay in Map1.CustomOverlays)
                {
                    //.Overlays 

                    if ((myOverlay) is LayerOverlay)
                    {

                        LayerOverlay layerOverlay = (LayerOverlay)myOverlay;

                        foreach (Layer myLayer in layerOverlay.Layers)
                        {

                            if (myLayer.HasBoundingBox)
                            {
                                if (!myLayer.IsOpen)
                                {
                                    myLayer.Open();
                                }

                                if (boundingBox == null)
                                {
                                    boundingBox = myLayer.GetBoundingBox();
                                }
                                else
                                {
                                    boundingBox.ExpandToInclude(myLayer.GetBoundingBox());
                                }
                            }
                        }
                    }
                }

                functionReturnValue = boundingBox;
            }
            catch (Exception ex)
            {

                System.Diagnostics.Debugger.Break();
            }

            return functionReturnValue;
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            Open_Raster_Map("~/App_Data/Erin 1.jpg");
        }
    }
}
